//////////////////////////////////////
//
//		ThouMkrs.cpp  (Utilities file)
//
//		Simple method to place thousands markers into a double
//		value.  Right now I'm only going to place "," between every
//		third number.  Later I'll check the [Intl] section in WIN.INI
//		for the sThousand value.
//
//

#include "stdafx.h"
#include "ThouMkrs.h"
#include <direct.h>

CString	PlaceThouChars(const double dwValue)
{
	CString	szValue;
	CString szTemp;
	char	szThouChar[2];
	int		iLength;
	int		iNoSeparators;
	int		iNoInFront;
	int		iCount;

	szValue.Format("%0.f", dwValue);

	iLength = szValue.GetLength();

	if (iLength < 4)
		return szValue;

	iNoSeparators = (int)(iLength / 3);
	iNoInFront = iLength % 3;

	if (iNoInFront)
		{
		szTemp = szValue.Left(iNoInFront);
		szTemp += ",";
		szTemp += szValue.Mid(iNoInFront, 3);
		}
	else
		szTemp = szValue.Left(3);
	
	iNoSeparators--;

	iCount = iNoInFront + 3;

	::GetProfileString("Intl", "sThousand", ",", szThouChar, 2);

	while(iNoSeparators)
		{
		szTemp += szThouChar;
		szTemp += szValue.Mid(iCount, 3);

		iNoSeparators--;

		iCount += 3;
		}

	return szTemp;
}


CString	GetMyFilePath(const CString *pszFileName)
{
	CString szTemp;
	int		iResult;

	iResult = pszFileName->ReverseFind('\\');

	if (iResult > 2)
		szTemp = pszFileName->Left(iResult);
	else
		szTemp = pszFileName->Left(iResult+1);

	return szTemp;
}

CString GetMyFileName(const CString *pszFileName)
{
	CString szTemp;
	int		iResult;
										
	iResult = pszFileName->ReverseFind('\\');

	szTemp = pszFileName->Mid(iResult+1);

	return szTemp;
}

CString ChangeMyPath(const CString *pszOldFName, const CString *pszNewPath)
{
	CString szTemp;

	szTemp = *pszNewPath + GetMyFileName(pszOldFName);

	return szTemp;
}

CString AddPath(const CString *pszOldFName, const CString *pszNewPath)
{
	CString szTemp;

	szTemp = pszOldFName->Right(pszOldFName->GetLength() - 3);

	szTemp = *pszNewPath + szTemp;

	return szTemp;
}

///////////////////////////
//
//	This function creates nested directories
//
//

BOOL	CheckPath(const CString *pszFName)
{
	CString szTemp; 
	CString	szDrive;

	CString szTemp2;

	char	buffer[_MAX_PATH];

	  /* Get the current working directory: */

	if( _getcwd( buffer, _MAX_PATH ) == NULL )
	   {
	   return FALSE;
	   }

	szTemp2 = GetMyFilePath(pszFName);

	int iTemp = 0;
	int	iHold = 0;

	BOOL bFlag = TRUE;
	
	while (bFlag)
		{
		iTemp = SuperFind(iTemp, &szTemp2, '\\');

		if (iTemp < 0)
			{
			bFlag = FALSE;

			if (_chdir(szTemp2))
				{
				//  Doesn't exist - create the directory:

				int iResult = _mkdir(szTemp2);
					
				if (iResult)
					{
					return FALSE;
					}
				}
			}
		else
			{
			iHold += iTemp + 1;

			szTemp = szTemp2.Left(iHold);

			iTemp = iHold + 1;

			if (_chdir(szTemp))
				{
				//  Doesn't exist - create the directory:

				int iResult = _mkdir(szTemp);
					
				if (iResult)
					{
					return FALSE;
					}
				}
			}
		}

	// Change back to original directory

	szDrive = buffer;

	_chdir(szDrive);

	return TRUE;
}

int	SuperFind(int iFrom, const CString *pszValue, char chChar)
{
	CString szTemp;
	int		iTemp;

	szTemp = pszValue->Mid(iFrom);

	iTemp = szTemp.Find(chChar);

	return iTemp;
}

/////////////////////////////
//
//  Change a file extention
//
//

CString ChangeExtention(const CString *pszOldFName, const CString *pszNewExt)
{
	CString szTemp;
	int iResult;

	iResult = pszOldFName->ReverseFind('.');

	if (iResult < 0)
		{
		szTemp = *pszOldFName + ".";
		}
	else
		{
		szTemp = pszOldFName->Left(iResult+1);
		}

	szTemp += *pszNewExt;

	return szTemp;
}

/////////////////////////////
//
//  Change a file name but keep the path
//
//


CString XchangeFileName(const CString *pszOldFileName, const CString *pszNewFileName)
{
	CString szTemp;
	CString szTemp2;

	szTemp = GetMyFilePath(pszOldFileName);

	if (szTemp.GetLength() > 3)
		szTemp += "\\";

	szTemp2 = GetMyFileName(pszNewFileName);

	szTemp2 = szTemp2.Left(szTemp2.GetLength() - 3);

	szTemp2 = szTemp2 + pszOldFileName->Right(3);

	szTemp = ChangeMyPath(&szTemp2, &szTemp);

	return szTemp;
}

/////////////////////////////
//
//  Add elipses to a string
//
//


CString SizeStringToFit(const CString *pszText, int len)
{
	CString szTemp;
	int		iNoChars;

	if (pszText->GetLength() > len)
		{
		iNoChars = ((len - 3)/2);

		szTemp = pszText->Left(iNoChars) + "..." + pszText->Right(iNoChars);
		}
	else
		szTemp = *pszText;

	return szTemp;
}

/////////////////////////////
//
//  Add number (iValue) to a file prefix
//
//


CString AddToFilePrefix(const CString *pszOldFileName, int iValue)
{
	CString szTemp;
	CString szTemp2;

	szTemp2 = pszOldFileName->Left(pszOldFileName->GetLength() - 4);

	szTemp.Format("%s %03d", (LPCSTR)szTemp2, (int)iValue);

	szTemp += pszOldFileName->Right(4);

	return szTemp;
}

CString AddToFilePrefix16(const CString *pszOldFileName, int iValue)
{
	CString szTemp;
	CString szTemp2;
	int		iLength;

	szTemp2 = *pszOldFileName;

	iLength = pszOldFileName->GetLength();

	switch(iLength)
		{
		case 12: szTemp = pszOldFileName->Left(iLength - 6);
				 break;

		case 11: szTemp = pszOldFileName->Left(iLength - 5);
				 break;

		default: szTemp = pszOldFileName->Left(iLength - 4);
		}


	szTemp2.Format("%s%02d", (LPCSTR)szTemp, (int)iValue);

	szTemp2 += pszOldFileName->Right(4);

	return szTemp2;
}

/////////////////////////////
//
//  Copy file routine which uses large memory buffer
//
//


BOOL myCopyFile(
    LPCTSTR lpExistingFileName,	// pointer to name of an existing file 
    LPCTSTR lpNewFileName,	// pointer to filename to copy to 
    BOOL bFailIfExists 	// flag for operation if file exists 
   )
{
	register int i;

	CFile	Old;
	CFile	New;

	CFileException	e;

	int		iLoopAmount;
	DWORD	dwFileSize;

	char	*Buffer = 0;
	int		iBuffSize = 512000;

	Buffer = new char[iBuffSize];

	if (!Buffer)
		{
		iBuffSize = 30000;

		Buffer = new char[iBuffSize];

		if (!Buffer)
			return FALSE;
		}

	if (Old.Open(lpExistingFileName, CFile::modeRead | CFile::shareDenyNone, &e))
		{
		dwFileSize = Old.GetLength();

		if (dwFileSize == 0xFFFFFFFF)
			{
			Old.Close();
			delete Buffer;
			return FALSE;
			}
		}
	else
		{
		delete Buffer;
		return FALSE;
		}

	//  Check if the New file already exists

	if (New.Open(lpNewFileName, CFile::modeRead | CFile::shareDenyNone, &e))
		{
		New.Close();

		if (bFailIfExists)
			{
			Old.Close();
			delete Buffer;
			return FALSE;
			}
		}

	//  Create the New file

	if( !New.Open(lpNewFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyNone, &e ) )
		{
		// Problem creating the new file
		Old.Close();
		delete Buffer;
		return FALSE;
		}

	iLoopAmount = dwFileSize / iBuffSize;

	for (i = 0; i < iLoopAmount; i++)
		{
		Old.Read(Buffer, iBuffSize);
		New.Write(Buffer, iBuffSize);
		}

	iLoopAmount = dwFileSize % iBuffSize;

	Old.Read(Buffer, iBuffSize);
	New.Write(Buffer, iBuffSize);

	Old.Close();
	New.Close();

	delete Buffer;

	return TRUE;
}


