// XDlg2.cpp : implementation file
//

#include "stdafx.h"
#include "Example11.h"
#include "XDlg2.h"
#include "ThouMkrs.h"
#include <dlgs.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString const szSection = "Import Recent Folder List";

#define MAXMULTIPATH	3000

/////////////////////////////////////////////////////////////////////////////
// CXDlg2 

IMPLEMENT_DYNAMIC(CXDlg2, CFileDialog)

CXDlg2::CXDlg2(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)
{
	SetTemplate(0, IDD_XFDLG2);

	m_bOKText = FALSE;

	m_pszFileName = new TCHAR[MAXMULTIPATH];

	m_pszFileName[0] = '\0';

	m_bMultiSelect = FALSE;
	
	//{{AFX_DATA_INIT(CXDlg2)
	//}}AFX_DATA_INIT
}

CXDlg2::~CXDlg2()
{
	if (m_pszFileName != NULL)
		delete []m_pszFileName;
}

void CXDlg2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXDlg2)
	DDX_Control(pDX, IDC_MRULIST, m_CtrlMRUList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXDlg2, CFileDialog)
	//{{AFX_MSG_MAP(CXDlg2)
	ON_CBN_SELCHANGE(IDC_MRULIST, OnSelchangeMRUList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXDlg2 message handlers

void CXDlg2::OnInitDone()
{
	CFileDialog::OnInitDone();

	CRect	r, rCurrent;

	CWnd*	pList = GetParent()->GetDlgItem(stc2);
	pList->GetWindowRect(r);
	GetParent()->ScreenToClient(r);

	CWnd*	pWnd = GetDlgItem(IDC_CAPTION);
	pWnd->GetWindowRect(rCurrent);
	GetParent()->ScreenToClient(rCurrent);

	pWnd->SetWindowPos(NULL,
						r.left,
						rCurrent.top,
						rCurrent.Width(),
						rCurrent.Height(),
						SWP_NOACTIVATE | SWP_NOZORDER);

	pList = GetParent()->GetDlgItem(cmb1);
	pList->GetWindowRect(r);
	GetParent()->ScreenToClient(r);

	pWnd = GetDlgItem(IDC_MRULIST);
	pWnd->GetWindowRect(rCurrent);
	GetParent()->ScreenToClient(rCurrent);

	pWnd->SetWindowPos(NULL,
						r.left,
						rCurrent.top,
						r.Width(),
						rCurrent.Height(),
						SWP_NOACTIVATE | SWP_NOZORDER);

	///////////////////////

	m_szPathName = AfxGetApp()->GetProfileString(szSection, "Folder1", "");

	if (m_szPathName.GetLength() > 0)
		{
		m_ofn.lpstrInitialDir = m_szPathName;
		}

	FillCombo();

	////////////////////////

	if (m_bOKText)
		{
		SetControlText(IDOK, m_OKButtonText); 
		}
}

void CXDlg2::OnSelchangeMRUList() 
{
	CString	szTemp;

	int	iIndex = m_CtrlMRUList.GetCurSel();
	
	m_CtrlMRUList.GetLBText(iIndex, szTemp);

	SetControlText(edt1,szTemp);

	GetParent()->SendMessage(WM_COMMAND,
				MAKEWPARAM(IDOK,BN_CLICKED),(long)GetDlgItem(IDOK)->GetSafeHwnd()); 

	szTemp = "";
	SetControlText(edt1,szTemp);
}

void CXDlg2::PushFolder(CString* pszPath)
{
	CString	szTemp, szTemp2, szTemp3;
	
	int	i, j;

	int	iResult;

	CWinApp* pApp;
	pApp = AfxGetApp();

	iResult = m_CtrlMRUList.FindStringExact(-1, *pszPath);

	if (iResult != CB_ERR)
		{
		// Already in the list

		// so let's remove it

		m_CtrlMRUList.DeleteString(iResult);
		}

	int iCount = m_CtrlMRUList.GetCount();

	if (iCount > 9)
		iCount = 9;

	for (i=iCount, j = iCount+1; i > 0; i--, j--)
		{
		szTemp2.Format("Folder%d", j);

		m_CtrlMRUList.GetLBText((i-1), szTemp);

		if (szTemp.GetLength() > 0)
			pApp->WriteProfileString(szSection, szTemp2, szTemp);
		}

	szTemp = *pszPath;

	if (szTemp.GetLength() > 0)
		{
		pApp->WriteProfileString(szSection, "Folder1", szTemp);
		m_CtrlMRUList.SetCurSel(0);
		}

}   

void CXDlg2::FillCombo(void)
{
	CWinApp* pApp;
	CString	 szTemp, szTemp2;

	pApp = AfxGetApp();
	 
	for (int i=1; i < 10; i++)
		{
		szTemp2.Format("Folder%d", i);
		szTemp = pApp->GetProfileString(szSection, szTemp2, "");

		if (szTemp.GetLength() > 0)
			m_CtrlMRUList.AddString(szTemp);
		}

	if (m_CtrlMRUList.GetCount())
		m_CtrlMRUList.SetCurSel(0);
}

BOOL CXDlg2::OnFileNameOK(void)
{
	CString szTemp, szTemp2;

	if (m_bMultiSelect)
		{
		POSITION	pos = GetStartPosition();

		szTemp = GetNextPathName(pos);
		}
	else
		{
		szTemp = GetPathName();
		}

	szTemp2 = GetMyFilePath(&szTemp);

	if (szTemp2.GetLength() > 3)
		szTemp2 += "\\";

	PushFolder(&szTemp2);

	return FALSE;	
}

void CXDlg2::SetOKButtonText(CString szText)
{
	m_OKButtonText = szText;
	m_bOKText = TRUE;
}

int	CXDlg2::DoModal()
{
	ASSERT(this);
	
	// ASSERT(m_ofn.Flags & OFN_ALLOWMULTISELECT);

	if (m_ofn.Flags & OFN_ALLOWMULTISELECT)
		{
		m_ofn.lpstrFile = m_pszFileName;
		m_ofn.nMaxFile = MAXMULTIPATH;

		m_bMultiSelect = TRUE;
		}

	return CFileDialog::DoModal();
}


